// base classes for CI predictors

#ifndef CIBASE_H
#define CIBASE_H

#include "mmatrix.H"
#include "../pose.H"
#include "kalmanUpdate.H"

#define MAXBEGIN 16
#define INITVAR 100


class CIKalmanBase
{
  public:
   CIKalmanBase() { }
   virtual ~CIKalmanBase() { }

   void ciKalmanFilter(Pose *userpos, int zNum, KALMANMODEL mod);

  protected:
    // hold for all state vectors
    MMatrix  _HH;
    MMatrix  _QQ;
    MMatrix  _RR;
    MMatrix  _fundMat;

    // unique for each position component
    MMatrix  _PP; 
    MMatrix  _state; 
};

class CIExtendedKalmanBase
{
  public:
    CIExtendedKalmanBase() { _up = new UpdaterLogExp(); }
    virtual ~CIExtendedKalmanBase() { delete _up; }

    void ciExtendedKalmanFilter(Pose *userpos, int zNum, KALMANMODEL mod);

  protected:
    MMatrix _EH;
    MMatrix _EQ;
    MMatrix _ER;
    MMatrix _EfundMat;
    MMatrix _EP;
    MMatrix _Estate;

   // since things have to be recomputed for every k we need to hold a few things
   double _edt;
   double _spd;

   UpdaterLogExp *_up;  // uses the updater for logexpmap rotations
};

#endif

