// header file for some functions that compute omega for
// the Covariance intersection Algorithm

#ifndef CIOMEGA_H
#define CIOMEGA_H

#include "mmatrix.H"

#define MaxDims 20

int ludcmp(MMatrix &a, int *indx, double *d, int n);
void lubksb(MMatrix &a, int indx[MaxDims], double b[MaxDims], int n);
int Invert(MMatrix &m, MMatrix &mi, int n);

double LogDet(MMatrix &A, int n);
double LogDetOfUpdate(double w, MMatrix &A1, MMatrix &A2, int n,
                      MMatrix &B1, MMatrix &B2, int m, MMatrix &H);
double ComputeOmegaCI(MMatrix &A1, MMatrix &A2, int n,
                      MMatrix &B1, MMatrix &B2, int m, MMatrix &H);  
double LogDetOfSum(double w, MMatrix &A1, MMatrix &A2, 
                   MMatrix &B1, MMatrix &B2, int n);
double ComputeOmegaCA(MMatrix &A1, MMatrix &A2, 
                      MMatrix &B1, MMatrix &B2, int n);



#endif
