// Header file for the exponential smoothing predictor

#ifndef EXPSMOOTH_H
#define EXPSMOOTH_H

#include "predictor.H"
#include "kalmanbase.H"

class ExpSmooth : public Predictor, KalmanBase, ExtendedKalmanBase
{
  public: 
    ExpSmooth();
    virtual ~ExpSmooth();

    virtual void prepare();
    virtual Pose * predict(Pose *userpos, double pinterval); 

    // actual prediction algorithms
    Pose * simpleExp(Pose *userpos, double pinterval);
    Pose * doubleExp(Pose *userpos, double pinterval);
    Pose * holtWinters(Pose *userpos, double pinterval);


  protected:
    double _alpha;
    double _beta;
    int    _initialize;
    int    _flag;
    int    _plo;
    int    _phi;
    Pose *_initpos;
    Pose *_initpos2;
    int   _ctr;
    
};



#endif
