// header file for Kalman filter based predictors

#ifndef KALMAN_H
#define KALMAN_H

#include "predictor.H"

class KalmanPVSM;
class KalmanPVASM;
class KalmanPVMMV;
class KalmanPVAMMV;
class KalmanPVAMMA;
class KalmanPVAMMVA;

class KalmanPredictor : public Predictor
{
 public:
   KalmanPredictor(); 
   virtual ~KalmanPredictor();

   virtual void prepare(); // prepares object for prediction
   virtual Pose * predict(Pose *userpos, double pinterval); 
    
  protected:   
    KalmanPVSM    *_pvsm;
    KalmanPVASM   *_pvasm;
    KalmanPVMMV   *_pvmmv;
    KalmanPVAMMV  *_pvammv;
    KalmanPVAMMA  *_pvamma;
    KalmanPVAMMVA *_pvammva;

};



#endif




