// header file for the position/velocity/acceleration, multiple measurement (position
// velocity, and acceleration) model

#ifndef KALMANPVAMMVA_H
#define KALMANPVAMMVA_H

#include "kalmanbase.H"

class Pose;

// kalman filter for a position/velocity/accel model with a multiple  measurement
// (i.e., position, velocity, and accel)
class KalmanPVAMMVA : public KalmanBase, ExtendedKalmanBase,
                      UnscentedKalmanBase
{
  public:
    KalmanPVAMMVA();
    virtual ~KalmanPVAMMVA(); 

    void initialize(double specd, double dt, double pn, double qn, double dv,
                    int ukfflag);
    Pose * filter(Pose *userpos, double pinterval);

  protected: 
    int    _ctr;
    int    _ukfflag;

};


#endif
