// header file for the position/velocity/acceleration, single measurment (position)
// model

#ifndef KALMANPVASM_H
#define KALMANPVASM_H


#include "kalmanbase.H"

class Pose;


// kalman filter for a position/velocity/acceleration model with single measurement
class KalmanPVASM : public KalmanBase, public ExtendedKalmanBase,
                    public UnscentedKalmanBase
{
  public:
    KalmanPVASM();
    virtual ~KalmanPVASM();

    void initialize(double specd, double dt, double pn, double qn, int ukfflag);
    Pose * filter(Pose *userpos, double pinterval);

  protected: 
    int    _ctr;
    int    _ukfflag;

};

#endif
