// header file for the Maybeck Style, 3 Model MMAE

#ifndef MMAE3MODEL_H
#define MMAE3MODEL_H

#include "mmaebase.H"
#include "types.H"

class Pose;


class MMAE3Model
{
  public:
   MMAE3Model();
   virtual ~MMAE3Model() { }

   void initialize(double specd, double dt, double pn, double qn, CombinerType cmb);
   Pose * filter(Pose *userpos, double pinterval);
  
   int getHighestModelKF();
   int getHighestModelEKF();

   void computeCondProbKF();
   void computeCondProbEKF();

   Vec3d predictPos(double pinterval);
   Quat  predictQuat(double pinterval);

 protected:
  int  _ctr;
  CombinerType _cmb;

  MMAEKalmanBase _kfmod[3];  // three individual models
  double _kfprob[3];       // need to hold the conditional probabilities
  double _kfprobtmp[3];  

  MMAEExtendedKalmanBase _ekfmod[3];
  double                 _ekfprob[3];
  double                 _ekfprobtmp[3];

};


#endif
