// File defines an abstract base class which all predictors must subclass.
// You must reimplement the predict function.


#ifndef PREDICTOR_H
#define PREDICTOR_H

#include "../pose.H"
#include "../pbundle.H"

// abstract base class
class Predictor
{
  public: 
    Predictor() : _paramb(0) { }
    virtual ~Predictor() { }

   // must be redefined
    virtual Pose * predict(Pose *userpos, double pinterval) = 0;  
    virtual void prepare() = 0;
    virtual void setParamBundle(ParamBundle *bnd) { _paramb = bnd; }  
  
  protected:
    ParamBundle *_paramb;
};


#endif
